unit samDATM;

interface
                  
uses
  WinTypes, WinProcs, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  addatecn, { This is required for the constants isDateTime etc }
  StdCtrls, adEdit, adbutedt, AdDateTm, ExtCtrls, Buttons, adchkbx,
  adCombo, Spin, AdCalSet, adddfcl, adpoppan,


  adWeek,   { Starting Day Of Week Type }
  AdDateCC, { This has the constants for the CalendarSettings.Options Type }
  AdCalPN, Tabs;

type
  TTAdrockDateTimeEditSampleForm = class(TForm)
    OpenDialog1: TOpenDialog;
    Notebook1: TNotebook;
    AsStringDisplayPanel: TPanel;
    LabelAsDateTime: TLabel;
    LabelAsDate: TLabel;
    LabelAsTime: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    BitBtn1: TBitBtn;
    DateTimeEditPanel: TPanel;
    TAdrockDateTimeEditLabel: TLabel;
    AdrockDateTimeEdit1: TAdrockDateTimeEdit;
    DisplayStylePanel: TPanel;
    LabelCustomDisplayFormat: TLabel;
    Label3: TLabel;
    DisplayFormatRadioGroup: TRadioGroup;
    DateDisplayStyleRadioGroup: TRadioGroup;
    TimeDisplayStyleRadioGroup: TRadioGroup;
    CustomDisplayFormat: TAdrockEdit;
    InputStylePanel: TPanel;
    Label2: TLabel;
    InputStyleRadioGroup: TRadioGroup;
    DateInputStyleRadioGroup: TRadioGroup;
    TimeInputStyleRadioGroup: TRadioGroup;
    OptionsPanel: TPanel;
    Bevel1: TBevel;
    Label1: TLabel;
    LabelShowMonthAs: TLabel;
    Bevel2: TBevel;
    Bevel3: TBevel;
    Label10: TLabel;
    Bevel4: TBevel;
    Label11: TLabel;
    Label12: TLabel;
    Bevel5: TBevel;
    Label13: TLabel;
    Label15: TLabel;
    CheckBox1: TAdrockCheckBox;
    AdrockCheckBoxReadOnly: TAdrockCheckBox;
    ComboBoxShowMonthAs: TAdrockComboBox;
    AdrockCheckBoxUseTabAsArrows: TAdrockCheckBox;
    ComboBoxWeekDayStyle: TAdrockComboBox;
    ComboBoxButtonBitmapStyle: TAdrockComboBox;
    ComboBoxButtonBitmapType: TAdrockComboBox;
    SelectCustomBitmapButton: TBitBtn;
    CreateDynamicControlButton: TBitBtn;
    DestroyDynamicControlButton: TBitBtn;
    GroupBox1: TGroupBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox5: TCheckBox;
    CheckBox4: TCheckBox;
    CheckBox6: TCheckBox;
    RadioGroup1: TRadioGroup;
    RadioGroup2: TRadioGroup;
    RadioGroup3: TRadioGroup;
    RadioGroup4: TRadioGroup;
    GroupBox2: TGroupBox;
    Label14: TLabel;
    Label16: TLabel;
    StartWeekDay: TComboBox;
    Week1Starts: TComboBox;
    ColorRadioGroup: TRadioGroup;
    ColorComboBox: TComboBox;
    AdrockCalendarPanel1: TAdrockCalendarPanel;
    ColorDialog1: TColorDialog;
    TabSet1: TTabSet;
    AdrockCalendarSettingsComponent1: TAdrockCalendarSettingsComponent;
    FontDialog1: TFontDialog;
    procedure AdrockDateTimeEdit1Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure DateInputStyleRadioGroupClick(Sender: TObject);
    procedure TimeInputStyleRadioGroupClick(Sender: TObject);
    procedure CustomDisplayFormatExit(Sender: TObject);
    procedure DisplayFormatRadioGroupClick(Sender: TObject);
    procedure DateDisplayStyleRadioGroupClick(Sender: TObject);
    procedure TimeDisplayStyleRadioGroupClick(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure AdrockCheckBoxReadOnlyClick(Sender: TObject);
    procedure ComboBoxShowMonthAsChange(Sender: TObject);
    procedure CustomDisplayFormatChange(Sender: TObject);
    procedure InputStyleRadioGroupClick(Sender: TObject);
    procedure AdrockCheckBoxUseTabAsArrowsClick(Sender: TObject);
    procedure ComboBoxWeekDayStyleChange(Sender: TObject);
    procedure ComboBoxButtonBitmapStyleChange(Sender: TObject);
    procedure AdrockCheckBoxUseTabAsArrowsEnter(Sender: TObject);
    procedure AdrockCheckBoxUseTabAsArrowsExit(Sender: TObject);
    procedure SelectCustomBitmapButtonClick(Sender: TObject);
    procedure ComboBoxButtonBitmapTypeChange(Sender: TObject);
    procedure CreateDynamicControlButtonClick(Sender: TObject);
    procedure DestroyDynamicControlButtonClick(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure CheckBox3Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure CheckBox4Click(Sender: TObject);
    procedure CheckBox5Click(Sender: TObject);
    procedure RadioButton1Click(Sender: TObject);
    procedure RadioGroup1Click(Sender: TObject);
    procedure RadioGroup2Click(Sender: TObject);
    procedure RadioGroup3Click(Sender: TObject);
    procedure RadioGroup4Click(Sender: TObject);
    procedure CheckBox6Click(Sender: TObject);
    procedure StartWeekDayChange(Sender: TObject);
    procedure Week1StartsChange(Sender: TObject);
    procedure ColorComboBoxChange(Sender: TObject);
    procedure ColorRadioGroupClick(Sender: TObject);
    procedure ColorComboBoxDrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure TabSet1Change(Sender: TObject; NewTab: Integer;
      var AllowChange: Boolean);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
    Function GetColorByIndex(Index : integer) : TColor;
    procedure SetColorByIndex(Index : integer; Color : TColor);
  public
    { Public declarations }
  end;

var
  fDataTimeEdit : TAdrockDateTimeEdit;
  TAdrockDateTimeEditSampleForm: TTAdrockDateTimeEditSampleForm;

implementation

{$R *.DFM}

procedure TTAdrockDateTimeEditSampleForm.AdrockDateTimeEdit1Change(Sender: TObject);
begin
     LabelAsDateTime.Caption := FormatDateTime('D MMMM, YYYY  HH:MM:SS AM/PM', (Sender as TAdrockDateTimeEdit).Date.DateTime);
     LabelAsDate.Caption     := FormatDateTime('D MMMM, YYYY  HH:MM:SS AM/PM', (Sender as TAdrockDateTimeEdit).Date.Date);
     LabelAsTime.Caption     := FormatDateTime('D MMMM, YYYY  HH:MM:SS AM/PM', (Sender as TAdrockDateTimeEdit).Date.Time);
end;

procedure TTAdrockDateTimeEditSampleForm.FormCreate(Sender: TObject);
begin
 NoteBook1.PageIndex := 0;
 StartWeekDay.ItemIndex := 0;
 Week1Starts.ItemIndex  := 0;
 AdrockDateTimeEdit1.Date.DateTime := Now;
 ComboBoxShowMonthAs.ItemIndex := 1;
 ComboBoxWeekDayStyle.ItemIndex := 0;
 ComboBoxButtonBitmapType.ItemIndex := 0;
 ComboBoxButtonBitmapStyle.ItemIndex := 0;
 SelectCustomBitmapButton.Glyph.Assign(AdrockDateTimeEdit1.ButtonBitmap);
end;

procedure TTAdrockDateTimeEditSampleForm.DateInputStyleRadioGroupClick(Sender: TObject);
begin
     Case DateInputStyleRadioGroup.ItemIndex of
       0 : AdrockDateTimeEdit1.DateInputStyle := disDMY;
       1 : AdrockDateTimeEdit1.DateInputStyle := disMDY;
       2 : AdrockDateTimeEdit1.DateInputStyle := disYMD;
       3 : AdrockDateTimeEdit1.DateInputStyle := disMonthYear;
       4 : AdrockDateTimeEdit1.DateInputStyle := disWeekDayDMY;
       5 : AdrockDateTimeEdit1.DateInputStyle := disWeekDayMDY;
       6 : AdrockDateTimeEdit1.DateInputStyle := disWeekDayYMD;
       7 : AdrockDateTimeEdit1.DateInputStyle := disWeekDayWindows;
       8 : AdrockDateTimeEdit1.DateInputStyle := disWindows;
     end;
end;

procedure TTAdrockDateTimeEditSampleForm.TimeInputStyleRadioGroupClick(
  Sender: TObject);
begin
     Case TimeInputStyleRadioGroup.ItemIndex of
       0 : AdrockDateTimeEdit1.TimeInputStyle := tisHM12;
       1 : AdrockDateTimeEdit1.TimeInputStyle := tisHM24;
       2 : AdrockDateTimeEdit1.TimeInputStyle := tisHMAMPM;
       3 : AdrockDateTimeEdit1.TimeInputStyle := tisHMS12;
       4 : AdrockDateTimeEdit1.TimeInputStyle := tisHMS24;
       5 : AdrockDateTimeEdit1.TimeInputStyle := tisHMSAMPM;
       6 : AdrockDateTimeEdit1.TimeInputStyle := tisWindowsLong;
       7 : AdrockDateTimeEdit1.TimeInputStyle := tisWindowsShort;
     end;
end;

procedure TTAdrockDateTimeEditSampleForm.CustomDisplayFormatExit(
  Sender: TObject);
begin
   AdrockDateTimeEdit1.CustomDisplayFormat := CustomDisplayFormat.Text;
end;

procedure TTAdrockDateTimeEditSampleForm.DisplayFormatRadioGroupClick(Sender: TObject);
begin
     Case DisplayFormatRadioGroup.ItemIndex of
       0 : AdrockDateTimeEdit1.DisplayStyle := dtdsDateStyle;
       1 : AdrockDateTimeEdit1.DisplayStyle := dtdsTimeStyle;
       2 : AdrockDateTimeEdit1.DisplayStyle := dtdsDateAndTimeStyle;
       3 : AdrockDateTimeEdit1.DisplayStyle := dtdsInputStyle;
       4 : AdrockDateTimeEdit1.DisplayStyle := dtdsCustom;
     end;
end;

procedure TTAdrockDateTimeEditSampleForm.DateDisplayStyleRadioGroupClick(
  Sender: TObject);
begin
     Case DateDisplayStyleRadioGroup.ItemIndex of
       0 : AdrockDateTimeEdit1.DateDisplayStyle := ddsDDMMYYYY;
       1 : AdrockDateTimeEdit1.DateDisplayStyle := ddsMMDDYYYY;
       2 : AdrockDateTimeEdit1.DateDisplayStyle := ddsYYYYMMDD;
       3 : AdrockDateTimeEdit1.DateDisplayStyle := ddsDateInputStyle;
       4 : AdrockDateTimeEdit1.DateDisplayStyle := ddsWindowsShortDate;
       5 : AdrockDateTimeEdit1.DateDisplayStyle := ddsWindowsLongDate;
       6 : AdrockDateTimeEdit1.DateDisplayStyle := ddsMonthYear;
       end;
end;

procedure TTAdrockDateTimeEditSampleForm.TimeDisplayStyleRadioGroupClick(
  Sender: TObject);
begin
     Case TimeDisplayStyleRadioGroup.ItemIndex of
       0 : AdrockDateTimeEdit1.TimeDisplayStyle := tdsHM12;
       1 : AdrockDateTimeEdit1.TimeDisplayStyle := tdsHM24;
       2 : AdrockDateTimeEdit1.TimeDisplayStyle := tdsHMS12;
       3 : AdrockDateTimeEdit1.TimeDisplayStyle := tdsHMS24;
       4 : AdrockDateTimeEdit1.TimeDisplayStyle := tdsHMAMPM;
       5 : AdrockDateTimeEdit1.TimeDisplayStyle := tdsHMSAMPM;
       6 : AdrockDateTimeEdit1.TimeDisplayStyle := tdsTimeInputStyle;
       7 : AdrockDateTimeEdit1.TimeDisplayStyle := tdsWindowsShortTime;
       8 : AdrockDateTimeEdit1.TimeDisplayStyle := tdsWindowsLongTime;
       end;
end;

procedure TTAdrockDateTimeEditSampleForm.CheckBox1Click(Sender: TObject);
begin
  AdrockDateTimeEdit1.Enabled := (Sender as TAdrockCheckBox).Checked;
end;



procedure TTAdrockDateTimeEditSampleForm.AdrockCheckBoxReadOnlyClick(
  Sender: TObject);
begin
  AdrockDateTimeEdit1.ReadOnly := (Sender as TAdrockCheckBox).Checked;
end;

procedure TTAdrockDateTimeEditSampleForm.ComboBoxShowMonthAsChange(
  Sender: TObject);
begin
  Case (Sender as TAdrockComboBox).ItemIndex of
    0 : AdrockDateTimeEdit1.ShowMonthAs := smNumber;
    1 : AdrockDateTimeEdit1.ShowMonthAs := smShortMonth;
    2 : AdrockDateTimeEdit1.ShowMonthAs := smLongMonth;
  end;


end;

procedure TTAdrockDateTimeEditSampleForm.CustomDisplayFormatChange(
  Sender: TObject);
begin
   AdrockDateTimeEdit1.CustomDisplayFormat :=CustomDisplayFormat.Text;
end;

procedure TTAdrockDateTimeEditSampleForm.InputStyleRadioGroupClick(
  Sender: TObject);
begin
     Case InputStyleRadioGroup.ItemIndex of
       0 : AdrockDateTimeEdit1.InputStyle := isDateTime;
       1 : AdrockDateTimeEdit1.InputStyle := isDate;
       2 : AdrockDateTimeEdit1.InputStyle := isTime;
       3 : AdrockDateTimeEdit1.InputStyle := isDateKeepTime;
       4 : AdrockDateTimeEdit1.InputStyle := isTimeKeepDate;
       5 : AdrockDateTimeEdit1.InputStyle := isFreeForm;
     end;
end;





procedure TTAdrockDateTimeEditSampleForm.AdrockCheckBoxUseTabAsArrowsClick(
  Sender: TObject);
begin
  if ((Sender as TAdrockCheckBox).Checked = true) then
    AdrockDateTimeEdit1.Options := AdrockDateTimeEdit1.Options + [deoUseTabAsArrows ]
  else
    AdrockDateTimeEdit1.Options := AdrockDateTimeEdit1.Options - [deoUseTabAsArrows ]
end;


procedure TTAdrockDateTimeEditSampleForm.ComboBoxWeekDayStyleChange(
  Sender: TObject);
begin
  Case (Sender as TAdrockComboBox).ItemIndex of
    0 : AdrockDateTimeEdit1.WeekDayStyle := wdsShortWeekDay;
    1 : AdrockDateTimeEdit1.WeekDayStyle := wdsLongWeekDay;
  end;
end;


procedure TTAdrockDateTimeEditSampleForm.ComboBoxButtonBitmapStyleChange(
  Sender: TObject);
begin
  Case (Sender as TAdrockComboBox).ItemIndex of
    0 : AdrockDateTimeEdit1.ButtonBitmapStyle := bsStandard;
    1 : AdrockDateTimeEdit1.ButtonBitmapStyle := bsCustom;
  end;
end;




procedure TTAdrockDateTimeEditSampleForm.AdrockCheckBoxUseTabAsArrowsEnter(
  Sender: TObject);
begin
  Label11.Font.Style := [fsBold];
end;

procedure TTAdrockDateTimeEditSampleForm.AdrockCheckBoxUseTabAsArrowsExit(
  Sender: TObject);
begin
  Label11.Font.Style := [];
end;

procedure TTAdrockDateTimeEditSampleForm.SelectCustomBitmapButtonClick(
  Sender: TObject);
begin
  if (OpenDialog1.Execute = TRUE) then
   begin
    SelectCustomBitmapButton.Glyph.LoadFromFile(OpenDialog1.FileName);
    AdrockDateTimeEdit1.ButtonBitmap.LoadFromFile(OpenDialog1.FileName);
    AdrockDateTimeEdit1.ButtonBitmapStyle := bsCustom;
    ComboBoxButtonBitmapStyle.ItemIndex := 1;
   end;
end;

procedure TTAdrockDateTimeEditSampleForm.ComboBoxButtonBitmapTypeChange(
  Sender: TObject);
begin
  Case (Sender as TAdrockComboBox).ItemIndex of
    0 : AdrockDateTimeEdit1.ButtonBitmapType := bbtDefault;
    1 : AdrockDateTimeEdit1.ButtonBitmapType := bbtCalendar;
    2 : AdrockDateTimeEdit1.ButtonBitmapType := bbtDate;
  end;
 ComboBoxButtonBitmapStyle.ItemIndex := 1;

end;

procedure TTAdrockDateTimeEditSampleForm.CreateDynamicControlButtonClick(Sender: TObject);
begin
  fDataTimeEdit := TAdrockDateTimeEdit.Create(Application);
  fDataTimeEdit.Parent := OptionsPanel;
  fDataTimeEdit.CalendarSettings := AdrockCalendarSettingsComponent1;
  fDataTimeEdit.Top    := 280;
  fDataTimeEdit.Left   := 65;
  CreateDynamicControlButton.Enabled := FALSE;
  DestroyDynamicControlButton.Enabled := TRUE;
end;

procedure TTAdrockDateTimeEditSampleForm.DestroyDynamicControlButtonClick(Sender: TObject);
begin
  fDataTimeEdit.Free;
  CreateDynamicControlButton.Enabled := TRUE;
  DestroyDynamicControlButton.Enabled := FALSE;
end;

procedure TTAdrockDateTimeEditSampleForm.CheckBox2Click(Sender: TObject);
begin
  if ((Sender as TCheckBox).Checked = TRUE) then
    AdrockCalendarSettingsComponent1.CalendarSettings.Options := AdrockCalendarSettingsComponent1.CalendarSettings.Options + [opShowAcceptCancelButtons]
  else
    AdrockCalendarSettingsComponent1.CalendarSettings.Options := AdrockCalendarSettingsComponent1.CalendarSettings.Options - [opShowAcceptCancelButtons];
end;

procedure TTAdrockDateTimeEditSampleForm.CheckBox3Click(Sender: TObject);
begin
  if ((Sender as TCheckBox).Checked = TRUE) then
    AdrockCalendarSettingsComponent1.CalendarSettings.Options := AdrockCalendarSettingsComponent1.CalendarSettings.Options + [opShowClearAndTodayButtons]
  else
    AdrockCalendarSettingsComponent1.CalendarSettings.Options := AdrockCalendarSettingsComponent1.CalendarSettings.Options - [opShowClearAndTodayButtons];
end;

procedure TTAdrockDateTimeEditSampleForm.BitBtn1Click(Sender: TObject);
begin
  ShowMessage('The date time is '+FormatDateTime('D MMMM, YYYY   HH:MM:SS AM/PM', AdrockDateTimeEdit1.Date.DateTime));
end;

procedure TTAdrockDateTimeEditSampleForm.CheckBox4Click(Sender: TObject);
begin
  if ((Sender as TCheckBox).Checked = TRUE) then
    AdrockCalendarSettingsComponent1.CalendarSettings.Options := AdrockCalendarSettingsComponent1.CalendarSettings.Options + [opShowDate]
  else
    AdrockCalendarSettingsComponent1.CalendarSettings.Options := AdrockCalendarSettingsComponent1.CalendarSettings.Options - [opShowDate];
end;

procedure TTAdrockDateTimeEditSampleForm.CheckBox5Click(Sender: TObject);
begin
  if ((Sender as TCheckBox).Checked = TRUE) then
    AdrockCalendarSettingsComponent1.CalendarSettings.Options := AdrockCalendarSettingsComponent1.CalendarSettings.Options + [opShowPrevNextMonth]
  else
    AdrockCalendarSettingsComponent1.CalendarSettings.Options := AdrockCalendarSettingsComponent1.CalendarSettings.Options - [opShowPrevNextMonth];
end;

procedure TTAdrockDateTimeEditSampleForm.RadioButton1Click(
  Sender: TObject);
begin
  if ((Sender as TRadioButton).Checked = TRUE) then
    AdrockCalendarSettingsComponent1.CalendarSettings.ShowOnCalendar := swMonthAndYearArrows;
end;

procedure TTAdrockDateTimeEditSampleForm.RadioGroup1Click(Sender: TObject);
begin
  Case ((Sender as TRadioGroup).ItemIndex) of
    0 : AdrockCalendarSettingsComponent1.CalendarSettings.Grid := cgNoGrid;
    1 : AdrockCalendarSettingsComponent1.CalendarSettings.Grid := cgCurrentMonth;
    2 : AdrockCalendarSettingsComponent1.CalendarSettings.Grid := cgWholeCalendar;
  end;
end;

procedure TTAdrockDateTimeEditSampleForm.RadioGroup2Click(Sender: TObject);
begin
  Case ((Sender as TRadioGroup).ItemIndex) of
    0 : AdrockCalendarSettingsComponent1.CalendarSettings.ShowOnCalendar := swNothing;
    1 : AdrockCalendarSettingsComponent1.CalendarSettings.ShowOnCalendar := swMonthArrows;
    2 : AdrockCalendarSettingsComponent1.CalendarSettings.ShowOnCalendar := swYearArrows;
    3 : AdrockCalendarSettingsComponent1.CalendarSettings.ShowOnCalendar := swMonthAndYearArrows;
    4 : AdrockCalendarSettingsComponent1.CalendarSettings.ShowOnCalendar := swAll;
  end;
end;

procedure TTAdrockDateTimeEditSampleForm.RadioGroup3Click(Sender: TObject);
begin
  Case ((Sender as TRadioGroup).ItemIndex) of
    0 : AdrockCalendarSettingsComponent1.CalendarSettings.ShowDateBevelAs := sbasRectangle;
    1 : AdrockCalendarSettingsComponent1.CalendarSettings.ShowDateBevelAs := sbasCircle;
  end;
end;

procedure TTAdrockDateTimeEditSampleForm.RadioGroup4Click(Sender: TObject);
begin
  Case ((Sender as TRadioGroup).ItemIndex) of
    0 : AdrockCalendarSettingsComponent1.CalendarSettings.ShowTodayBevelAs := sbasRectangle;
    1 : AdrockCalendarSettingsComponent1.CalendarSettings.ShowTodayBevelAs := sbasCircle;
  end;
end;

procedure TTAdrockDateTimeEditSampleForm.CheckBox6Click(Sender: TObject);
begin
  AdrockCalendarSettingsComponent1.CalendarSettings.WeekDayHeader.WeekNumbers :=(Sender as TCheckBox).Checked;
  if ((Sender as TCheckBox).Checked = TRUE) then
    AdrockCalendarSettingsComponent1.CalendarSettings.Options := AdrockCalendarSettingsComponent1.CalendarSettings.Options + [opShowWeekNumbers]
  else
    AdrockCalendarSettingsComponent1.CalendarSettings.Options := AdrockCalendarSettingsComponent1.CalendarSettings.Options - [opShowWeekNumbers];
end;

procedure TTAdrockDateTimeEditSampleForm.StartWeekDayChange(Sender: TObject);
begin
  AdrockCalendarSettingsComponent1.CalendarSettings.WeekDayHeader.StartDayOfWeek := TAdrockWeekDay(StartWeekDay.ItemIndex);
  AdrockCalendarSettingsComponent1.CalendarSettings.WeekStart := TAdrockWeekDay(StartWeekDay.ItemIndex);
  AdrockCalendarSettingsComponent1.Change;
end;

procedure TTAdrockDateTimeEditSampleForm.Week1StartsChange(Sender: TObject);
begin
  case (Week1Starts.ItemIndex) of
    0 : AdrockCalendarSettingsComponent1.CalendarSettings.WeekNumberStyle := wsFirstJan1;
    1 : AdrockCalendarSettingsComponent1.CalendarSettings.WeekNumberStyle := wsFirstFullWeek;
    2 : AdrockCalendarSettingsComponent1.CalendarSettings.WeekNumberStyle := wsFirstFourDayWeek;
  end;
end;

procedure TTAdrockDateTimeEditSampleForm.ColorComboBoxChange(Sender: TObject);
Var
  OldColor,
  NewColor : TColor;
begin
  OldColor := clRed;
  if (ColorComboBox.ItemIndex = ColorComboBox.Items.Count-1) then
   begin
     { User Defined }
     ColorDialog1.Color := OldColor;
     if (ColorDialog1.Execute = TRUE) then
       NewColor := ColorDialog1.Color
     else
      exit;
   end
  else
    NewColor := StringToColor(ColorComboBox.Text);
  SetColorByIndex(ColorRadioGroup.ItemIndex, newColor);
end;

Function TTAdrockDateTimeEditSampleForm.GetColorByIndex(Index : integer) : TColor;
begin
  case Index of
     0 : { Back             }
         Result := AdrockCalendarSettingsComponent1.CalendarSettings.Colors.Back;
     1 : { CaptionBack      }
         Result := AdrockCalendarSettingsComponent1.CalendarSettings.Colors.CaptionBack;
     2 : { DateBevel        }
         Result := AdrockCalendarSettingsComponent1.CalendarSettings.Colors.DateBevel;
     3 : { Grid             }
         Result := AdrockCalendarSettingsComponent1.CalendarSettings.Colors.Grid;
     4 : { GridBackground   }
         Result := AdrockCalendarSettingsComponent1.CalendarSettings.Colors.GridBackground;
     5 : { Highlight        }
         Result := AdrockCalendarSettingsComponent1.CalendarSettings.Colors.Highlight;
     6 : { MonFri           }
         Result := AdrockCalendarSettingsComponent1.CalendarSettings.Colors.MonFri;
     7 : { Normal           }
         Result := AdrockCalendarSettingsComponent1.CalendarSettings.Colors.Normal;
     8 : { PrevNextMonth    }
         Result := AdrockCalendarSettingsComponent1.CalendarSettings.Colors.PrevNextMonth;
     9 : { RangeErrors      }
         Result := AdrockCalendarSettingsComponent1.CalendarSettings.Colors.RangeErrors;
    10 : { Saturday         }
         Result := AdrockCalendarSettingsComponent1.CalendarSettings.Colors.Saturday;
    11 : { Sunday           }
         Result := AdrockCalendarSettingsComponent1.CalendarSettings.Colors.Sunday;
    12 : { Selected         }
         Result := AdrockCalendarSettingsComponent1.CalendarSettings.Colors.Selected;
    13 : { StatusBack       }
         Result := AdrockCalendarSettingsComponent1.CalendarSettings.Colors.StatusBack;
    14 : { Today            }
         Result := AdrockCalendarSettingsComponent1.CalendarSettings.Colors.Today;
    15 : { Todayrect        }
         Result := AdrockCalendarSettingsComponent1.CalendarSettings.Colors.TodayRect;
    16 : { WeekDay          }
         Result := AdrockCalendarSettingsComponent1.CalendarSettings.Colors.WeekDay;
    17 : { WeekNumber       }
         Result := AdrockCalendarSettingsComponent1.CalendarSettings.Colors.WeekNumber;
    18 : { WeekNumberBack   }
         Result := AdrockCalendarSettingsComponent1.CalendarSettings.Colors.WeekNumberBack;
else
  result :=0;
  end;
end;

procedure TTAdrockDateTimeEditSampleForm.SetColorByIndex(Index : integer; Color : TColor);
begin
  case Index of
     0 : { Back             }
         AdrockCalendarSettingsComponent1.CalendarSettings.Colors.Back := Color;
     1 : { CaptionBack      }
         AdrockCalendarSettingsComponent1.CalendarSettings.Colors.CaptionBack := Color;
     2 : { DateBevel        }
         AdrockCalendarSettingsComponent1.CalendarSettings.Colors.DateBevel := Color;
     3 : { Grid             }
         AdrockCalendarSettingsComponent1.CalendarSettings.Colors.Grid := Color;
     4 : { GridBackground   }
         AdrockCalendarSettingsComponent1.CalendarSettings.Colors.GridBackground := Color;
     5 : { Highlight        }
         AdrockCalendarSettingsComponent1.CalendarSettings.Colors.Highlight := Color;
     6 : { MonFri           }
         AdrockCalendarSettingsComponent1.CalendarSettings.Colors.MonFri := Color;
     7 : { Normal           }
         AdrockCalendarSettingsComponent1.CalendarSettings.Colors.Normal := Color;
     8 : { PrevNextMonth    }
         AdrockCalendarSettingsComponent1.CalendarSettings.Colors.PrevNextMonth := Color;
     9 : { RangeErrors      }
         AdrockCalendarSettingsComponent1.CalendarSettings.Colors.RangeErrors := Color;
    10 : { Saturday         }
         AdrockCalendarSettingsComponent1.CalendarSettings.Colors.Saturday := Color;
    11 : { Sunday           }
         AdrockCalendarSettingsComponent1.CalendarSettings.Colors.Sunday := Color;
    12 : { Selected         }
         AdrockCalendarSettingsComponent1.CalendarSettings.Colors.Selected := Color;
    13 : { StatusBack       }
         AdrockCalendarSettingsComponent1.CalendarSettings.Colors.StatusBack := Color;
    14 : { Today            }
         AdrockCalendarSettingsComponent1.CalendarSettings.Colors.Today := Color;
    15 : { Todayrect        }
         AdrockCalendarSettingsComponent1.CalendarSettings.Colors.TodayRect := Color;
    16 : { WeekDay          }
         AdrockCalendarSettingsComponent1.CalendarSettings.Colors.WeekDay := Color;
    17 : { WeekNumber       }
         AdrockCalendarSettingsComponent1.CalendarSettings.Colors.WeekNumber := Color;
    18 : { WeekNumberBack   }
         AdrockCalendarSettingsComponent1.CalendarSettings.Colors.WeekNumberBack := Color;
  end;
end;


procedure TTAdrockDateTimeEditSampleForm.ColorRadioGroupClick(Sender: TObject);
Var
  TheColor    : TColor;
  ColorString : String;
begin
  TheColor := GetColorByIndex(ColorRadioGroup.ItemIndex);
  ColorString := ColorToString(TheColor);
  if (ColorComboBox.Items.IndexOf(ColorString) <> -1) then
    ColorComboBox.ItemIndex := ColorComboBox.Items.IndexOf(ColorString)
  else
    ColorComboBox.ItemIndex := ColorComboBox.Items.Count-1;
end;

procedure TTAdrockDateTimeEditSampleForm.ColorComboBoxDrawItem(
  Control: TWinControl; Index: Integer; Rect: TRect;
  State: TOwnerDrawState);
Var
 fRect : TRect;
begin
  with ColorComboBox.Canvas do
   begin
     fillRect(Rect);
     fRect := Rect;
     Dec(fRect.Right,20);
     textrect(fRect, fRect.Left+1, fRect.Top, ColorComboBox.Items.Strings[Index]);
     fRect := Rect;
     fRect.Left := fRect.Right-18;
     InflateRect(fRect,-1,-1);
     if (Index  = ColorComboBox.Items.Count-1) then
       Brush.Color := GetColorByIndex(ColorRadioGroup.ItemIndex)
     else
       Brush.Color := StringToColor(ColorComboBox.Items.Strings[Index]);
     FillRect(fRect);
   end;
end;

procedure TTAdrockDateTimeEditSampleForm.TabSet1Change(Sender: TObject;
  NewTab: Integer; var AllowChange: Boolean);
begin
  NoteBook1.PageIndex := NewTab;
end;

procedure TTAdrockDateTimeEditSampleForm.Button1Click(Sender: TObject);
begin
  FontDialog1.Font.Assign(AdrockCalendarSettingsComponent1.CalendarSettings.Font);
  if (FontDialog1.Execute = TRUE) then
    AdrockCalendarSettingsComponent1.CalendarSettings.Font.Assign(FontDialog1.Font);
end;

end.
