unit adDSuite;

interface


Uses
  Classes,  { Declares RegisterComponents}
  DsgnIntf, { Register Component Editor }

  AdDtRegc, { TAdrockDateTimeEdit Component Editor     }
  AdcsRegc, { TAdrockCalendarSettings Component Editor }
  AdcpRegc, { TAdrockCalendarPanel Component Editor    }
  Ad3dCal,  { TAdrock3dCalendar                    }
  adCalPN,  { TAdrockCalendarPanel                 }
  AdDateTm, { TAdrockDateTimeEdit                  }
  AdButEdt, { TAdrockButtonEdit                    }
  adCBEdit, { TAdrockAutoCompletionButtonEdit      }
  AdcalSet, { TAdrockCalendarSettingsComponent     }
  AdCalc,   { TAdrockCalculatorEdit                }

  AdDBDaTm, { TAdrockDBDateTimeEdit                }
  AdDBCalc; { TAdrockDBCalculatorEdit              }

{ Declare the Register Routine that will Register the Components with Delphi }
procedure Register;

implementation

procedure Register;
begin
  { Register (Standard Versions) TAdrock3dCalendar }
  RegisterComponents('Adrock', [TAdrockCalendarSettingsComponent]);
  RegisterComponents('Adrock', [TAdrockButtonEdit, TAdrockAutoCompletionButtonEdit]);

  RegisterComponents('Adrock', [TAdrock3dCalendar, TAdrockCalcEdit, TAdrockDateTimeEdit]);
  RegisterComponents('Adrock', [TAdrockCalendarPanel]);

  { Register (Data-Aware Versions) TAdrockDBEdit, TAdrockDBMemo, TAdrockDBListBox, TAdrockDBComboBox }
  RegisterComponents('Adrock', [TAdrockDBCalcEdit, TAdrockDBDateTimeEdit]);

  RegisterComponentEditor(TAdrockCalendarPanel, TAdrockCalendarPanelComponentEditor);
  RegisterComponentEditor(TAdrockCalendarSettingsComponent, TAdrockCalendarSettingsComponentEditor);
  RegisterComponentEditor(TAdrockDateTimeEdit, TAdrockDateTimeComponentEditor);
  RegisterComponentEditor(TAdrockDBDateTimeEdit, TAdrockDateTimeComponentEditor);
end;

end.
